SystemOrganization addCategory: #'Seaside-Tests-FileSystem'!

TestCase subclass: #WAExternalFileLibraryTest
	instanceVariableNames: 'fileSystem'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Tests-FileSystem'!

!WAExternalFileLibraryTest methodsFor: 'private' stamp: 'mlucas-smith 6/4/2009 16:53'!
requestWithUrl: aString
	^WARequest
		method: 'POST'
		url: (WAUrl new parsePath: aString)
		headers: Dictionary new
		fields: Dictionary new
		cookies: Array new
		remoteAddress: ''! !

!WAExternalFileLibraryTest methodsFor: 'running' stamp: 'pmm 10/18/2008 10:39'!
setUp
	super setUp.
	fileSystem := WAExternalFileLibrary new.
	fileSystem setName: 'culture'! !

!WAExternalFileLibraryTest methodsFor: 'testing' stamp: 'pmm 10/18/2008 11:28'!
testAsAbsoluteUrlRelativeTo
	| request |
	fileSystem configuration valueAt: #directory put: '/home/philppe/pr0n'.
	request := self requestWithUrl: '/culture/pictures'.
	self assert: (fileSystem asAbsoluteUrl: 'cleopatra.jpeg' relativeTo: request) seasideString = '/culture/pictures/cleopatra.jpeg'.
	
	request := self requestWithUrl: '/culture/pictures/'.
	self assert: (fileSystem asAbsoluteUrl: 'cleopatra.jpeg' relativeTo: request) seasideString = '/culture/pictures/cleopatra.jpeg'.! !

!WAExternalFileLibraryTest methodsFor: 'testing' stamp: 'pmm 10/18/2008 11:31'!
testMimetypeForRequest
	| request |
	request := self requestWithUrl: '/culture/pictures/cleopatra.jpeg'.
	self assert: (fileSystem mimetypeForRequest: request) = 'image/jpeg' seasideMimeType.
	
	request := self requestWithUrl: '/culture/pictures/cleopatra'.
	self assert: (fileSystem mimetypeForRequest: request) = 'application/octet-stream' seasideMimeType.
	
	request := self requestWithUrl: '/culture/pictures/cleopatra.'.
	self assert: (fileSystem mimetypeForRequest: request) = 'application/octet-stream' seasideMimeType.
	
	request := self requestWithUrl: '/'.
	self assert: (fileSystem mimetypeForRequest: request) = 'application/octet-stream' seasideMimeType.
	
	request := self requestWithUrl: '/culture/pictures/cleopatra.js'.
	self assert: (fileSystem mimetypeForRequest: request) = 'application/x-javascript' seasideMimeType.! !

!WAExternalFileLibraryTest methodsFor: 'testing' stamp: 'pmm 7/18/2009 10:17'!
testPathForRequest
	"self debug: #testPathForRequest"

	| request |
	fileSystem configuration valueAt: #directory put: '/home/philppe/files'.
	"/culture is mapped to /home/philppe/files"
	
	"If you're looking this test and it doesn't seem to make sense, keep in mind that a file name is this context is an SpFilename, which is a path."
	request := self requestWithUrl: '/culture/cleopatra.jpeg'.
	self assert: (fileSystem filenameForRequest: request) seasideString = '/home/philppe/files/cleopatra.jpeg'.
	
	fileSystem configuration valueAt: #directory put: '/home/philppe/files/'.
	self assert: (fileSystem filenameForRequest: request) seasideString = '/home/philppe/files/cleopatra.jpeg'.
	
	fileSystem configuration valueAt: #directory put: '/home/philppe/files'.
	request := self requestWithUrl: 'culture/cleopatra.jpeg'.
	self assert: (fileSystem filenameForRequest: request) seasideString = '/home/philppe/files/cleopatra.jpeg'.
	
	fileSystem configuration valueAt: #directory put: '/home/philppe/files/'.
	self assert: (fileSystem filenameForRequest: request) seasideString = '/home/philppe/files/cleopatra.jpeg'! !
